From 4336e99dab66385bf76c920099c49f2fd7636dd9 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Fri, 30 May 2014 15:13:02 -0400
Subject: [PATCH 005/119] Replace BB_HEAD et al macros with functions

This is further scaffolding; convert the BB_* and SET_BB_* macros
into functions.  Convert the BB_* rvalue-style functions into returning
rtx_insn * rather than plain rtx.

For now, this is done by adding a checked cast, but this will eventually
become a field lookup.  The lvalue form for now returns an rtx& to allow
in-place modification.

gcc/
	* basic-block.h (BB_HEAD): Convert to a function.  Strengthen the
	return type from rtx to rtx_insn *.
	(BB_END): Likewise.
	(BB_HEADER): Likewise.
	(BB_FOOTER): Likewise.
	(SET_BB_HEAD): Convert to a function.
	(SET_BB_END): Likewise.
	(SET_BB_HEADER): Likewise.
	(SET_BB_FOOTER): Likewise.

	* cfgrtl.c (BB_HEAD): New function, from macro of same name.
	Strengthen the return type from rtx to rtx_insn *.  For now, this
	is done by adding a checked cast, but this will eventually
	become a field lookup.
	(BB_END): Likewise.
	(BB_HEADER): Likewise.
	(BB_FOOTER): Likewise.
	(SET_BB_HEAD): New function, from macro of same name.  This is
	intended for use as an lvalue, and so returns an rtx& to allow
	in-place modification.
	(SET_BB_END): Likewise.
	(SET_BB_HEADER): Likewise.
	(SET_BB_FOOTER): Likewise.
---
 gcc/basic-block.h | 26 ++++++++++++++----------
 gcc/cfgrtl.c      | 60 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 75 insertions(+), 11 deletions(-)

diff --git a/gcc/basic-block.h b/gcc/basic-block.h
index d27f498..82dbfe9 100644
--- a/gcc/basic-block.h
+++ b/gcc/basic-block.h
@@ -368,17 +368,21 @@ struct GTY(()) control_flow_graph {
 
 /* Stuff for recording basic block info.  */
 
-/* These macros are currently split into two:
-   one suitable for reading, and for writing.
-   These will become functions in a follow-up patch.  */
-#define BB_HEAD(B)      (((const_basic_block)B)->il.x.head_)
-#define SET_BB_HEAD(B)  (B)->il.x.head_
-#define BB_END(B)       (((const rtl_bb_info *)(B)->il.x.rtl)->end_)
-#define SET_BB_END(B)   (B)->il.x.rtl->end_
-#define BB_HEADER(B)    (((const rtl_bb_info *)(B)->il.x.rtl)->header_)
-#define SET_BB_HEADER(B) (B)->il.x.rtl->header_
-#define BB_FOOTER(B)    (((const rtl_bb_info *)(B)->il.x.rtl)->footer_)
-#define SET_BB_FOOTER(B) (B)->il.x.rtl->footer_
+/* For now, these will be functions (so that they can include checked casts
+   to rtx_insn.   Once the underlying fields are converted from rtx
+   to rtx_insn, these can be converted back to macros.  */
+
+extern rtx_insn *BB_HEAD (const_basic_block bb);
+extern rtx& SET_BB_HEAD (basic_block bb);
+
+extern rtx_insn *BB_END (const_basic_block bb);
+extern rtx& SET_BB_END (basic_block bb);
+
+extern rtx_insn *BB_HEADER (const_basic_block bb);
+extern rtx& SET_BB_HEADER (basic_block bb);
+
+extern rtx_insn *BB_FOOTER (const_basic_block bb);
+extern rtx& SET_BB_FOOTER (basic_block bb);
 
 /* Special block numbers [markers] for entry and exit.
    Neither of them is supposed to hold actual statements.  */
diff --git a/gcc/cfgrtl.c b/gcc/cfgrtl.c
index 026fb48..2a5d4a7 100644
--- a/gcc/cfgrtl.c
+++ b/gcc/cfgrtl.c
@@ -5094,4 +5094,64 @@ struct cfg_hooks cfg_layout_rtl_cfg_hooks = {
   rtl_account_profile_record,
 };
 
+/* BB_HEAD as an rvalue. */
+
+rtx_insn *BB_HEAD (const_basic_block bb)
+{
+  rtx insn = bb->il.x.head_;
+  return insn ? as_a <rtx_insn *> (insn) : NULL;
+}
+
+/* BB_HEAD for use as an lvalue. */
+
+rtx& SET_BB_HEAD (basic_block bb)
+{
+  return bb->il.x.head_;
+}
+
+/* BB_END as an rvalue. */
+
+rtx_insn *BB_END (const_basic_block bb)
+{
+  rtx insn = bb->il.x.rtl->end_;
+  return insn ? as_a <rtx_insn *> (insn) : NULL;
+}
+
+/* BB_END as an lvalue. */
+
+rtx& SET_BB_END (basic_block bb)
+{
+  return bb->il.x.rtl->end_;
+}
+
+/* BB_HEADER as an rvalue. */
+
+rtx_insn *BB_HEADER (const_basic_block bb)
+{
+  rtx insn = bb->il.x.rtl->header_;
+  return insn ? as_a <rtx_insn *> (insn) : NULL;
+}
+
+/* BB_HEADER as an lvalue. */
+
+rtx& SET_BB_HEADER (basic_block bb)
+{
+  return bb->il.x.rtl->header_;
+}
+
+/* BB_FOOTER as an rvalue. */
+
+rtx_insn *BB_FOOTER (const_basic_block bb)
+{
+  rtx insn = bb->il.x.rtl->footer_;
+  return insn ? as_a <rtx_insn *> (insn) : NULL;
+}
+
+/* BB_FOOTER as an lvalue. */
+
+rtx& SET_BB_FOOTER (basic_block bb)
+{
+  return bb->il.x.rtl->footer_;
+}
+
 #include "gt-cfgrtl.h"
-- 
1.8.5.3

